from psychopy import visual, event, gui, monitors
from numpy import *
import sys

Answ = {'Greyscale (0) or Sine Waves (1)':'', 'Spatial Frequency':'', 'Screen Resolution Width (e.g. 1024)':'', 'Screen Resolution Height (e.g. 768)':'','Width of Monitor Image':'','Hot Points (0,1,2 or 3 - Greyscale req. 0)':'0','Number of Luminances to Test (at least 10)':''}
# create a dialog box, DlgFromDict.   See GUI.py for more possiblilities
startUpQuest = gui.DlgFromDict(dictionary=Answ, title='To Sine or Not to Sine?')
if startUpQuest.OK: #this will be True (user hit OK) or False (cancelled)
    sined = int(Answ['Greyscale (0) or Sine Waves (1)'])
    nRead = int(Answ['Number of Luminances to Test (at least 10)'])
    srW = int(Answ['Screen Resolution Width (e.g. 1024)'])
    srH = int(Answ['Screen Resolution Height (e.g. 768)'])
    mW = float(Answ['Width of Monitor Image'])
    hPs = int(Answ['Hot Points (0,1,2 or 3 - Greyscale req. 0)'])
else:
    print 'User cancelled, exiting'
    sys.exit()

if hPs >= 1:
    if hPs == 1:
        hPsAnsw = {'Location (between 0 and 1)':''}
    elif hPs == 2:
        hPsAnsw = {'Location of the first (between 0 and 1)':'','Location of the second (between 0 and 1)':''}
    elif hPs == 3:
        hPsAnsw = {'Location of the first (between 0 and 1)':'','Location of the second (between 0 and 1)':'','Location of the third (between 0 and 1)':''}
    hPsAnal = gui.DlgFromDict(dictionary=hPsAnsw, title='Select your Hot Points')
    if hPsAnal.OK:
        hPsList = [float(j) for i, j in hPsAnsw.iteritems()]
    else:
        print 'User cancelled, exiting'
        sys.exit()

if sined:
    theTex = 'sin'
    sfreq = float(Answ['Spatial Frequency'])
elif not sined:
    theTex = 'None'
    sfreq = 0
else:
    print 'Something wrong with the sined logic'

mon = monitors.Monitor(name='testMonitor', distance = '57', width=mW)
win = visual.Window(monitor='testMonitor',size=[srW,srH],fullscr=1,units ='pix',screen=0,waitBlanking=False)

toSine = visual.PatchStim(win,tex=theTex,texRes=1024, mask='None', contrast = 1.0,
           units='pix', size=[srW,srH], sf=sfreq, pos=[0,0], ori = 0, autoLog=False)

stopTest = False
phasesAre = []
coloursAre = []
if sined:
    if hPs>=1:
        extraPhases = ((nRead - 10) / len(hPsList))/2
        for i in hPsList:
#            phasesAre.append(i)
            for j in xrange(extraPhases):
                if i != 0.0:
                    phasesAre.append(abs(i - (j*1.0/1024.0)))
                if i != 1.0:
                    phasesAre.append(i + (j*1.0/1024.0))
    denom = range(1,11)
    for i in denom:
        eachPhase = i * 1.0/len(denom)
        phasesAre.append(eachPhase)
#    print 'phasesAre (before) =', phasesAre
    phasesAre = list(set(phasesAre))
    phasesAre.sort()
#    print 'phasesAre (after) =', phasesAre
    print 'Number of Luminances actually tested =', len(phasesAre)
    phasesToTest = ((array(phasesAre)-0.5))*2
    print 'Those phases (as fractions of pi) were: ', phasesToTest
else:
    coloursAre = []
    for r in range(nRead):
        eachCol = -1.0 + (r*2.0/(nRead-1))
        coloursAre.append(eachCol)
        coloursAre = list(set(coloursAre))
        coloursAre.sort()
    print 'Number of Luminances actually tested =', len(coloursAre)
    print 'Those Luminances (as RGB values from -1 to 1) were: ', coloursAre
nDone = 0

while not stopTest:
    if sined: #Let's work on the Sine waves first
        thePhse=phasesAre[nDone]
        toSine.setPhase(thePhse)
        toSine.draw()
        win.flip()
        for key in event.getKeys():
            if key in ['q','escape']:
                stopTest = True
                break
        awaitingSpace=True
        while awaitingSpace:
            for key in event.getKeys():
                if key in ['space']:
                    awaitingSpace = False
                    nDone+=1
                elif key in ['backspace']:
                    nDone-=1
                elif key in ['q','escape']:
                    stopTest = True
                    awaitingSpace = False
                    break
    elif stopTest:
        break
    elif not sined: #Let's work on the Sine waves first
        theCol = coloursAre[nDone]
        toSine.setColor(theCol)
        toSine.draw()
        win.flip()
        for key in event.getKeys():
            if key in ['q','escape']:
                stopTest = True
                break
        awaitingSpace=True
        while awaitingSpace:
            for key in event.getKeys():
                if key in ['space']:
                    awaitingSpace = False
                    nDone+=1
                elif key in ['backspace']:
                    nDone-=1
                elif key in ['q','escape']:
                    stopTest = True
                    awaitingSpace = False
                    break
    if nDone == len(phasesAre) or nDone == len(coloursAre):
        stopTest = True
        break

#once the program is over, just clean up
win.close()